/* -*-Mode: C;-*-
 *
 * Copyright (C) 1999, 2000, Joshua P. MacDonald <jmacd@CS.Berkeley.EDU>
 * and The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *    Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 *    Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *
 *    Neither name of The University of California nor the names of
 *    its contributors may be used to endorse or promote products
 *    derived from this software without specific prior written
 *    permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * This file was AUTOMATICALLY GENERATED using:
 *
 * $Id: edsio.el 1.2 Tue, 13 Jun 2000 01:19:56 -0700 jmacd $
 */

#include "xdfs.h"

#include <errno.h>

/* Declarations. */

static const char* Xdfs_Path_event_field_to_string (GenericEvent* ev, gint field);
static const char* Xdfs_PathInt_event_field_to_string (GenericEvent* ev, gint field);
static const char* Xdfs_Int_event_field_to_string (GenericEvent* ev, gint field);
static void print_spaces (guint n) { int i; for (i = 0; i < n; i += 1) g_print (" "); }


/* initialize this library. */

gboolean
xdfs_edsio_init (void)
{
  static gboolean once = FALSE;
  static gboolean result = FALSE;
  if (once) return result;
  once = TRUE;
  eventdelivery_initialize_event_def (EC_XdfsFsyncFailedValue, EL_Error, EF_None, "FsyncFailed", "Fsync failed", NULL);
  eventdelivery_initialize_event_def (EC_XdfsUnlinkFailedValue, EL_Error, EF_None, "UnlinkFailed", "Unlink failed: ${0}", & Xdfs_Int_event_field_to_string);
  eventdelivery_initialize_event_def (EC_XdfsCannotDeleteRootValue, EL_Error, EF_None, "CannotDeleteRoot", "Can't delete the root directory", NULL);
  eventdelivery_initialize_event_def (EC_XdfsNoSuchViewValue, EL_Error, EF_None, "NoSuchView", "No such view: ${0}", & Xdfs_Int_event_field_to_string);
  eventdelivery_initialize_event_def (EC_XdfsAlreadyExistsValue, EL_Error, EF_None, "AlreadyExists", "Key already exists", NULL);
  eventdelivery_initialize_event_def (EC_XdfsStatFailedValue, EL_Error, EF_None, "StatFailed", "Stat failed: ${0} ${1}", & Xdfs_PathInt_event_field_to_string);
  eventdelivery_initialize_event_def (EC_XdfsNotADirectoryValue, EL_Error, EF_None, "NotADirectory", "Not a directory: ${0}", & Xdfs_Path_event_field_to_string);
  eventdelivery_initialize_event_def (EC_XdfsInvalidFileTypeValue, EL_Error, EF_None, "InvalidFileType", "Invalid file type: ${0}", & Xdfs_Int_event_field_to_string);
  eventdelivery_initialize_event_def (EC_XdfsMkdirFailedValue, EL_Error, EF_None, "MkdirFailed", "Mkdir failed: ${0} ${1}", & Xdfs_PathInt_event_field_to_string);
  eventdelivery_initialize_event_def (EC_XdfsCloseFailedValue, EL_Error, EF_None, "CloseFailed", "Close failed: ${0}", & Xdfs_Path_event_field_to_string);
  eventdelivery_initialize_event_def (EC_XdfsWriteFailedValue, EL_Error, EF_None, "WriteFailed", "Write failed: ${0}", & Xdfs_Path_event_field_to_string);
  eventdelivery_initialize_event_def (EC_XdfsMunmapFailedValue, EL_Error, EF_None, "MunmapFailed", "Munmap failed: ${0}", & Xdfs_Int_event_field_to_string);
  eventdelivery_initialize_event_def (EC_XdfsMmapFailedValue, EL_Error, EF_None, "MmapFailed", "Mmap failed: ${0}", & Xdfs_Int_event_field_to_string);
  eventdelivery_initialize_event_def (EC_XdfsOpenReadFailedValue, EL_Error, EF_None, "OpenReadFailed", "Open read failed: ${0}", & Xdfs_Path_event_field_to_string);
  eventdelivery_initialize_event_def (EC_XdfsOpenWriteFailedValue, EL_Error, EF_None, "OpenWriteFailed", "Open write failed: ${0}", & Xdfs_Path_event_field_to_string);
  eventdelivery_initialize_event_def (EC_XdfsMalformedCanonicalPathValue, EL_Error, EF_None, "MalformedCanonicalPath", "Malformed canonical path", NULL);
  eventdelivery_initialize_event_def (EC_XdfsFileExistsValue, EL_Error, EF_None, "FileExists", "File exists: ${0}", & Xdfs_Path_event_field_to_string);
  eventdelivery_initialize_event_def (EC_XdfsImmutableContainerValue, EL_Error, EF_None, "ImmutableContainer", "Immutable conatiner: ${0}", & Xdfs_Path_event_field_to_string);
  eventdelivery_initialize_event_def (EC_XdfsIndirectLinkDepthExceededValue, EL_Error, EF_None, "IndirectLinkDepthExceeded", "Maximum indirect link depth exceeded", NULL);
  eventdelivery_initialize_event_def (EC_XdfsLinkDepthExceededValue, EL_Error, EF_None, "LinkDepthExceeded", "Maximum link depth exceeded: ${0}", & Xdfs_Path_event_field_to_string);
  eventdelivery_initialize_event_def (EC_XdfsInvalidRecordLengthValue, EL_Error, EF_None, "InvalidRecordLength", "Invalid record length", NULL);
  eventdelivery_initialize_event_def (EC_XdfsMissingShortValue, EL_Error, EF_None, "MissingShort", "Missing short", NULL);
  eventdelivery_initialize_event_def (EC_XdfsMissingLinkValue, EL_Error, EF_None, "MissingLink", "Missing link", NULL);
  eventdelivery_initialize_event_def (EC_XdfsMissingInodeValue, EL_Error, EF_None, "MissingInode", "Missing inode", NULL);
  eventdelivery_initialize_event_def (EC_XdfsDbCursorCloseValue, EL_Error, EF_None, "DbCursorClose", "db_cursor_close: ${0}", & Xdfs_Int_event_field_to_string);
  eventdelivery_initialize_event_def (EC_XdfsDbCursorDelValue, EL_Error, EF_None, "DbCursorDel", "db_cursor_del: ${0}", & Xdfs_Int_event_field_to_string);
  eventdelivery_initialize_event_def (EC_XdfsDbCursorGetValue, EL_Error, EF_None, "DbCursorGet", "db_cursor_get: ${0}", & Xdfs_Int_event_field_to_string);
  eventdelivery_initialize_event_def (EC_XdfsDbCursorValue, EL_Error, EF_None, "DbCursor", "db_cursor: ${0}", & Xdfs_Int_event_field_to_string);
  eventdelivery_initialize_event_def (EC_XdfsDbEnvOpenValue, EL_Error, EF_None, "DbEnvOpen", "db_env_open: ${0} ${1}", & Xdfs_PathInt_event_field_to_string);
  eventdelivery_initialize_event_def (EC_XdfsDbEnvCreateValue, EL_Error, EF_None, "DbEnvCreate", "db_env_create: ${0}", & Xdfs_Int_event_field_to_string);
  eventdelivery_initialize_event_def (EC_XdfsDbMempFputValue, EL_Error, EF_None, "DbMempFput", "db_memp_fput: ${0}", & Xdfs_Int_event_field_to_string);
  eventdelivery_initialize_event_def (EC_XdfsDbMempFcloseValue, EL_Error, EF_None, "DbMempFclose", "db_memp_fclose: ${0}", & Xdfs_Int_event_field_to_string);
  eventdelivery_initialize_event_def (EC_XdfsDbMempFgetValue, EL_Error, EF_None, "DbMempFget", "db_memp_fget: ${0}", & Xdfs_Int_event_field_to_string);
  eventdelivery_initialize_event_def (EC_XdfsDbMempFopenValue, EL_Error, EF_None, "DbMempFopen", "db_memp_fopen: ${0}", & Xdfs_Int_event_field_to_string);
  eventdelivery_initialize_event_def (EC_XdfsDbTxnCheckpointValue, EL_Error, EF_None, "DbTxnCheckpoint", "db_txn_checkpoint: ${0}", & Xdfs_Int_event_field_to_string);
  eventdelivery_initialize_event_def (EC_XdfsDbTxnAbortValue, EL_Error, EF_None, "DbTxnAbort", "db_txn_abort: ${0}", & Xdfs_Int_event_field_to_string);
  eventdelivery_initialize_event_def (EC_XdfsDbTxnCommitValue, EL_Error, EF_None, "DbTxnCommit", "db_txn_commit: ${0}", & Xdfs_Int_event_field_to_string);
  eventdelivery_initialize_event_def (EC_XdfsDbTxnBeginValue, EL_Error, EF_None, "DbTxnBegin", "db_txn_begin: ${0}", & Xdfs_Int_event_field_to_string);
  eventdelivery_initialize_event_def (EC_XdfsDbDelValue, EL_Error, EF_None, "DbDel", "db_del: ${0}", & Xdfs_Int_event_field_to_string);
  eventdelivery_initialize_event_def (EC_XdfsDbPutValue, EL_Error, EF_None, "DbPut", "db_put: ${0}", & Xdfs_Int_event_field_to_string);
  eventdelivery_initialize_event_def (EC_XdfsDbGetValue, EL_Error, EF_None, "DbGet", "db_get: ${0}", & Xdfs_Int_event_field_to_string);
  eventdelivery_initialize_event_def (EC_XdfsDbSetValue, EL_Error, EF_None, "DbSet", "db_set: ${0}", & Xdfs_Int_event_field_to_string);
  eventdelivery_initialize_event_def (EC_XdfsDbCreateValue, EL_Error, EF_None, "DbCreate", "db_create: ${0}", & Xdfs_Int_event_field_to_string);
  eventdelivery_initialize_event_def (EC_XdfsDbEnvCloseValue, EL_Error, EF_None, "DbEnvClose", "db_env_close: ${0}", & Xdfs_Int_event_field_to_string);
  eventdelivery_initialize_event_def (EC_XdfsDbCloseValue, EL_Error, EF_None, "DbClose", "db_close: ${0}", & Xdfs_Int_event_field_to_string);
  eventdelivery_initialize_event_def (EC_XdfsDbOpenValue, EL_Error, EF_None, "DbOpen", "db_open: ${0}", & Xdfs_Int_event_field_to_string);
  serializeio_initialize_type ("ST_XdfsState", ST_XdfsState, &unserialize_xdfsstate_internal, &serialize_xdfsstate_obj_internal, &serializeio_count_xdfsstate_obj, &serializeio_print_xdfsstate_obj);
  serializeio_initialize_type ("ST_XdfsInstruction", ST_XdfsInstruction, &unserialize_xdfsinstruction_internal, &serialize_xdfsinstruction_obj_internal, &serializeio_count_xdfsinstruction_obj, &serializeio_print_xdfsinstruction_obj);
  edsio_library_register (10, "xdfs");
  result = TRUE;
  return TRUE;
};

/* XdfsInstruction Count
 */

guint
serializeio_count_xdfsinstruction (guint32 offset, guint32 length, guint32 output_start) {
  guint size = sizeof (SerialXdfsInstruction);
  ALIGN_8 (size);
  ALIGN_8 (size);
  ALIGN_8 (size);
  ALIGN_8 (size);
  return size;
}

guint
serializeio_count_xdfsinstruction_obj (SerialXdfsInstruction const* obj) {
  return serializeio_count_xdfsinstruction (obj->offset, obj->length, obj->output_start);
}

/* XdfsInstruction Print
 */

void
serializeio_print_xdfsinstruction_obj (SerialXdfsInstruction* obj, guint indent_spaces) {
  g_print ("{\n");
  print_spaces (indent_spaces);
  g_print ("offset:uint = ");
  g_print ("%d\n", obj->offset);
  print_spaces (indent_spaces);
  g_print ("length:uint = ");
  g_print ("%d\n", obj->length);
  print_spaces (indent_spaces);
  g_print ("output_start:uint = ");
  g_print ("%d\n", obj->output_start);
  print_spaces (indent_spaces);
  g_print ("}\n");
}

/* XdfsInstruction Serialize
 */

gboolean
serialize_xdfsinstruction_internal (SerialSink *sink, guint32 offset, guint32 length, guint32 output_start)
{
  if (! (* sink->next_uint) (sink, offset)) goto bail;
  if (! (* sink->next_uint) (sink, length)) goto bail;
  if (! (* sink->next_uint) (sink, output_start)) goto bail;
  return TRUE;
bail:
  return FALSE;
}

gboolean
serialize_xdfsinstruction_obj_internal (SerialSink *sink, SerialXdfsInstruction* obj)
{
  return serialize_xdfsinstruction_internal (sink, obj->offset, obj->length, obj->output_start);
}

gboolean
serialize_xdfsinstruction (SerialSink *sink, guint32 offset, guint32 length, guint32 output_start)
{
  if (! (* sink->sink_type) (sink, ST_XdfsInstruction, serializeio_count_xdfsinstruction (offset, length, output_start), TRUE)) goto bail;
  if (! serialize_xdfsinstruction_internal (sink, offset, length, output_start)) goto bail;
  if (sink->sink_quantum && ! sink->sink_quantum (sink)) goto bail;
  return TRUE;
bail:
  return FALSE;
}

gboolean
serialize_xdfsinstruction_obj (SerialSink *sink, const SerialXdfsInstruction* obj) {

  return serialize_xdfsinstruction (sink, obj->offset, obj->length, obj->output_start);
}

/* XdfsInstruction Unserialize
 */

gboolean
unserialize_xdfsinstruction_internal_noalloc (SerialSource *source, SerialXdfsInstruction* result)
{
  if (! (* source->next_uint) (source, &result->offset)) goto bail;
  if (! (* source->next_uint) (source, &result->length)) goto bail;
  if (! (* source->next_uint) (source, &result->output_start)) goto bail;
  return TRUE;
bail:
  return FALSE;
}

gboolean
unserialize_xdfsinstruction_internal (SerialSource *source, SerialXdfsInstruction** result)
{
  SerialXdfsInstruction* unser;
  (*result) = NULL;
  unser = serializeio_source_alloc (source, sizeof (SerialXdfsInstruction));
  if (! unser) goto bail;
  if (! unserialize_xdfsinstruction_internal_noalloc (source, unser)) goto bail;
  (*result) = unser;
  return TRUE;
bail:
  return FALSE;
}

gboolean
unserialize_xdfsinstruction (SerialSource *source, SerialXdfsInstruction** result)
{
  SerialType t = (* source->source_type) (source, TRUE);
  if (t != ST_XdfsInstruction) { edsio_generate_void_event (EC_EdsioUnexpectedType); goto bail; }
  if (! unserialize_xdfsinstruction_internal (source, result)) goto bail;
  if (! serializeio_source_object_received (source)) goto bail;
  return TRUE;
bail:
  return FALSE;
}

/* XdfsState Count
 */

guint
serializeio_count_xdfsstate (guint32 src_buffer_files, guint32 src_buffer_size, guint32 total_version_count, guint32 unique_version_count, guint32 unencoded_size, guint32 literal_size, guint32 control_size, guint32 patch_size, guint32 patches, guint32 literals, guint32 src_buffer_copied, guint32 cluster_versions, guint32 cluster_compressed_size, guint32 cluster_uncompressed_size, guint32 policy, guint32 flags, guint32 cluster_max_versions, guint32 src_buffer_max_files, guint32 src_buffer_max_size, guint32 src_buffer_max_size_per_file, guint32 src_buffer_min_size_per_file) {
  guint size = sizeof (SerialXdfsState);
  ALIGN_8 (size);
  ALIGN_8 (size);
  ALIGN_8 (size);
  ALIGN_8 (size);
  ALIGN_8 (size);
  ALIGN_8 (size);
  ALIGN_8 (size);
  ALIGN_8 (size);
  ALIGN_8 (size);
  ALIGN_8 (size);
  ALIGN_8 (size);
  ALIGN_8 (size);
  ALIGN_8 (size);
  ALIGN_8 (size);
  ALIGN_8 (size);
  ALIGN_8 (size);
  ALIGN_8 (size);
  ALIGN_8 (size);
  ALIGN_8 (size);
  ALIGN_8 (size);
  ALIGN_8 (size);
  ALIGN_8 (size);
  return size;
}

guint
serializeio_count_xdfsstate_obj (SerialXdfsState const* obj) {
  return serializeio_count_xdfsstate (obj->src_buffer_files, obj->src_buffer_size, obj->total_version_count, obj->unique_version_count, obj->unencoded_size, obj->literal_size, obj->control_size, obj->patch_size, obj->patches, obj->literals, obj->src_buffer_copied, obj->cluster_versions, obj->cluster_compressed_size, obj->cluster_uncompressed_size, obj->policy, obj->flags, obj->cluster_max_versions, obj->src_buffer_max_files, obj->src_buffer_max_size, obj->src_buffer_max_size_per_file, obj->src_buffer_min_size_per_file);
}

/* XdfsState Print
 */

void
serializeio_print_xdfsstate_obj (SerialXdfsState* obj, guint indent_spaces) {
  g_print ("{\n");
  print_spaces (indent_spaces);
  g_print ("src_buffer_files:uint = ");
  g_print ("%d\n", obj->src_buffer_files);
  print_spaces (indent_spaces);
  g_print ("src_buffer_size:uint = ");
  g_print ("%d\n", obj->src_buffer_size);
  print_spaces (indent_spaces);
  g_print ("total_version_count:uint = ");
  g_print ("%d\n", obj->total_version_count);
  print_spaces (indent_spaces);
  g_print ("unique_version_count:uint = ");
  g_print ("%d\n", obj->unique_version_count);
  print_spaces (indent_spaces);
  g_print ("unencoded_size:uint = ");
  g_print ("%d\n", obj->unencoded_size);
  print_spaces (indent_spaces);
  g_print ("literal_size:uint = ");
  g_print ("%d\n", obj->literal_size);
  print_spaces (indent_spaces);
  g_print ("control_size:uint = ");
  g_print ("%d\n", obj->control_size);
  print_spaces (indent_spaces);
  g_print ("patch_size:uint = ");
  g_print ("%d\n", obj->patch_size);
  print_spaces (indent_spaces);
  g_print ("patches:uint = ");
  g_print ("%d\n", obj->patches);
  print_spaces (indent_spaces);
  g_print ("literals:uint = ");
  g_print ("%d\n", obj->literals);
  print_spaces (indent_spaces);
  g_print ("src_buffer_copied:uint = ");
  g_print ("%d\n", obj->src_buffer_copied);
  print_spaces (indent_spaces);
  g_print ("cluster_versions:uint = ");
  g_print ("%d\n", obj->cluster_versions);
  print_spaces (indent_spaces);
  g_print ("cluster_compressed_size:uint = ");
  g_print ("%d\n", obj->cluster_compressed_size);
  print_spaces (indent_spaces);
  g_print ("cluster_uncompressed_size:uint = ");
  g_print ("%d\n", obj->cluster_uncompressed_size);
  print_spaces (indent_spaces);
  g_print ("policy:uint = ");
  g_print ("%d\n", obj->policy);
  print_spaces (indent_spaces);
  g_print ("flags:uint = ");
  g_print ("%d\n", obj->flags);
  print_spaces (indent_spaces);
  g_print ("cluster_max_versions:uint = ");
  g_print ("%d\n", obj->cluster_max_versions);
  print_spaces (indent_spaces);
  g_print ("src_buffer_max_files:uint = ");
  g_print ("%d\n", obj->src_buffer_max_files);
  print_spaces (indent_spaces);
  g_print ("src_buffer_max_size:uint = ");
  g_print ("%d\n", obj->src_buffer_max_size);
  print_spaces (indent_spaces);
  g_print ("src_buffer_max_size_per_file:uint = ");
  g_print ("%d\n", obj->src_buffer_max_size_per_file);
  print_spaces (indent_spaces);
  g_print ("src_buffer_min_size_per_file:uint = ");
  g_print ("%d\n", obj->src_buffer_min_size_per_file);
  print_spaces (indent_spaces);
  g_print ("}\n");
}

/* XdfsState Serialize
 */

gboolean
serialize_xdfsstate_internal (SerialSink *sink, guint32 src_buffer_files, guint32 src_buffer_size, guint32 total_version_count, guint32 unique_version_count, guint32 unencoded_size, guint32 literal_size, guint32 control_size, guint32 patch_size, guint32 patches, guint32 literals, guint32 src_buffer_copied, guint32 cluster_versions, guint32 cluster_compressed_size, guint32 cluster_uncompressed_size, guint32 policy, guint32 flags, guint32 cluster_max_versions, guint32 src_buffer_max_files, guint32 src_buffer_max_size, guint32 src_buffer_max_size_per_file, guint32 src_buffer_min_size_per_file)
{
  if (! (* sink->next_uint) (sink, src_buffer_files)) goto bail;
  if (! (* sink->next_uint) (sink, src_buffer_size)) goto bail;
  if (! (* sink->next_uint) (sink, total_version_count)) goto bail;
  if (! (* sink->next_uint) (sink, unique_version_count)) goto bail;
  if (! (* sink->next_uint) (sink, unencoded_size)) goto bail;
  if (! (* sink->next_uint) (sink, literal_size)) goto bail;
  if (! (* sink->next_uint) (sink, control_size)) goto bail;
  if (! (* sink->next_uint) (sink, patch_size)) goto bail;
  if (! (* sink->next_uint) (sink, patches)) goto bail;
  if (! (* sink->next_uint) (sink, literals)) goto bail;
  if (! (* sink->next_uint) (sink, src_buffer_copied)) goto bail;
  if (! (* sink->next_uint) (sink, cluster_versions)) goto bail;
  if (! (* sink->next_uint) (sink, cluster_compressed_size)) goto bail;
  if (! (* sink->next_uint) (sink, cluster_uncompressed_size)) goto bail;
  if (! (* sink->next_uint) (sink, policy)) goto bail;
  if (! (* sink->next_uint) (sink, flags)) goto bail;
  if (! (* sink->next_uint) (sink, cluster_max_versions)) goto bail;
  if (! (* sink->next_uint) (sink, src_buffer_max_files)) goto bail;
  if (! (* sink->next_uint) (sink, src_buffer_max_size)) goto bail;
  if (! (* sink->next_uint) (sink, src_buffer_max_size_per_file)) goto bail;
  if (! (* sink->next_uint) (sink, src_buffer_min_size_per_file)) goto bail;
  return TRUE;
bail:
  return FALSE;
}

gboolean
serialize_xdfsstate_obj_internal (SerialSink *sink, SerialXdfsState* obj)
{
  return serialize_xdfsstate_internal (sink, obj->src_buffer_files, obj->src_buffer_size, obj->total_version_count, obj->unique_version_count, obj->unencoded_size, obj->literal_size, obj->control_size, obj->patch_size, obj->patches, obj->literals, obj->src_buffer_copied, obj->cluster_versions, obj->cluster_compressed_size, obj->cluster_uncompressed_size, obj->policy, obj->flags, obj->cluster_max_versions, obj->src_buffer_max_files, obj->src_buffer_max_size, obj->src_buffer_max_size_per_file, obj->src_buffer_min_size_per_file);
}

gboolean
serialize_xdfsstate (SerialSink *sink, guint32 src_buffer_files, guint32 src_buffer_size, guint32 total_version_count, guint32 unique_version_count, guint32 unencoded_size, guint32 literal_size, guint32 control_size, guint32 patch_size, guint32 patches, guint32 literals, guint32 src_buffer_copied, guint32 cluster_versions, guint32 cluster_compressed_size, guint32 cluster_uncompressed_size, guint32 policy, guint32 flags, guint32 cluster_max_versions, guint32 src_buffer_max_files, guint32 src_buffer_max_size, guint32 src_buffer_max_size_per_file, guint32 src_buffer_min_size_per_file)
{
  if (! (* sink->sink_type) (sink, ST_XdfsState, serializeio_count_xdfsstate (src_buffer_files, src_buffer_size, total_version_count, unique_version_count, unencoded_size, literal_size, control_size, patch_size, patches, literals, src_buffer_copied, cluster_versions, cluster_compressed_size, cluster_uncompressed_size, policy, flags, cluster_max_versions, src_buffer_max_files, src_buffer_max_size, src_buffer_max_size_per_file, src_buffer_min_size_per_file), TRUE)) goto bail;
  if (! serialize_xdfsstate_internal (sink, src_buffer_files, src_buffer_size, total_version_count, unique_version_count, unencoded_size, literal_size, control_size, patch_size, patches, literals, src_buffer_copied, cluster_versions, cluster_compressed_size, cluster_uncompressed_size, policy, flags, cluster_max_versions, src_buffer_max_files, src_buffer_max_size, src_buffer_max_size_per_file, src_buffer_min_size_per_file)) goto bail;
  if (sink->sink_quantum && ! sink->sink_quantum (sink)) goto bail;
  return TRUE;
bail:
  return FALSE;
}

gboolean
serialize_xdfsstate_obj (SerialSink *sink, const SerialXdfsState* obj) {

  return serialize_xdfsstate (sink, obj->src_buffer_files, obj->src_buffer_size, obj->total_version_count, obj->unique_version_count, obj->unencoded_size, obj->literal_size, obj->control_size, obj->patch_size, obj->patches, obj->literals, obj->src_buffer_copied, obj->cluster_versions, obj->cluster_compressed_size, obj->cluster_uncompressed_size, obj->policy, obj->flags, obj->cluster_max_versions, obj->src_buffer_max_files, obj->src_buffer_max_size, obj->src_buffer_max_size_per_file, obj->src_buffer_min_size_per_file);
}

/* XdfsState Unserialize
 */

gboolean
unserialize_xdfsstate_internal_noalloc (SerialSource *source, SerialXdfsState* result)
{
  if (! (* source->next_uint) (source, &result->src_buffer_files)) goto bail;
  if (! (* source->next_uint) (source, &result->src_buffer_size)) goto bail;
  if (! (* source->next_uint) (source, &result->total_version_count)) goto bail;
  if (! (* source->next_uint) (source, &result->unique_version_count)) goto bail;
  if (! (* source->next_uint) (source, &result->unencoded_size)) goto bail;
  if (! (* source->next_uint) (source, &result->literal_size)) goto bail;
  if (! (* source->next_uint) (source, &result->control_size)) goto bail;
  if (! (* source->next_uint) (source, &result->patch_size)) goto bail;
  if (! (* source->next_uint) (source, &result->patches)) goto bail;
  if (! (* source->next_uint) (source, &result->literals)) goto bail;
  if (! (* source->next_uint) (source, &result->src_buffer_copied)) goto bail;
  if (! (* source->next_uint) (source, &result->cluster_versions)) goto bail;
  if (! (* source->next_uint) (source, &result->cluster_compressed_size)) goto bail;
  if (! (* source->next_uint) (source, &result->cluster_uncompressed_size)) goto bail;
  if (! (* source->next_uint) (source, &result->policy)) goto bail;
  if (! (* source->next_uint) (source, &result->flags)) goto bail;
  if (! (* source->next_uint) (source, &result->cluster_max_versions)) goto bail;
  if (! (* source->next_uint) (source, &result->src_buffer_max_files)) goto bail;
  if (! (* source->next_uint) (source, &result->src_buffer_max_size)) goto bail;
  if (! (* source->next_uint) (source, &result->src_buffer_max_size_per_file)) goto bail;
  if (! (* source->next_uint) (source, &result->src_buffer_min_size_per_file)) goto bail;
  return TRUE;
bail:
  return FALSE;
}

gboolean
unserialize_xdfsstate_internal (SerialSource *source, SerialXdfsState** result)
{
  SerialXdfsState* unser;
  (*result) = NULL;
  unser = serializeio_source_alloc (source, sizeof (SerialXdfsState));
  if (! unser) goto bail;
  if (! unserialize_xdfsstate_internal_noalloc (source, unser)) goto bail;
  (*result) = unser;
  return TRUE;
bail:
  return FALSE;
}

gboolean
unserialize_xdfsstate (SerialSource *source, SerialXdfsState** result)
{
  SerialType t = (* source->source_type) (source, TRUE);
  if (t != ST_XdfsState) { edsio_generate_void_event (EC_EdsioUnexpectedType); goto bail; }
  if (! unserialize_xdfsstate_internal (source, result)) goto bail;
  if (! serializeio_source_object_received (source)) goto bail;
  return TRUE;
bail:
  return FALSE;
}

void
xdfs_generate_int_event_internal (XdfsIntEventCode _code, const char* _srcfile, gint _srcline, int err)
{
  XdfsIntEvent *_e = g_new0 (XdfsIntEvent, 1);
  _e->code = _code.code;
  _e->srcline = _srcline;
  _e->srcfile = _srcfile;
  _e->err = err;
  eventdelivery_event_deliver ((GenericEvent*) _e);
}

const char*
Xdfs_Int_event_field_to_string (GenericEvent* ev, gint field)
{
  XdfsIntEvent* it = (XdfsIntEvent*) ev;
  switch (field)
    {
    case 0: return eventdelivery_int_to_string (it->err);
    default: abort ();
    }
}

const XdfsIntEventCode EC_XdfsDbOpen = { EC_XdfsDbOpenValue };

const XdfsIntEventCode EC_XdfsDbClose = { EC_XdfsDbCloseValue };

const XdfsIntEventCode EC_XdfsDbEnvClose = { EC_XdfsDbEnvCloseValue };

const XdfsIntEventCode EC_XdfsDbCreate = { EC_XdfsDbCreateValue };

const XdfsIntEventCode EC_XdfsDbSet = { EC_XdfsDbSetValue };

const XdfsIntEventCode EC_XdfsDbGet = { EC_XdfsDbGetValue };

const XdfsIntEventCode EC_XdfsDbPut = { EC_XdfsDbPutValue };

const XdfsIntEventCode EC_XdfsDbDel = { EC_XdfsDbDelValue };

const XdfsIntEventCode EC_XdfsDbTxnBegin = { EC_XdfsDbTxnBeginValue };

const XdfsIntEventCode EC_XdfsDbTxnCommit = { EC_XdfsDbTxnCommitValue };

const XdfsIntEventCode EC_XdfsDbTxnAbort = { EC_XdfsDbTxnAbortValue };

const XdfsIntEventCode EC_XdfsDbTxnCheckpoint = { EC_XdfsDbTxnCheckpointValue };

const XdfsIntEventCode EC_XdfsDbMempFopen = { EC_XdfsDbMempFopenValue };

const XdfsIntEventCode EC_XdfsDbMempFget = { EC_XdfsDbMempFgetValue };

const XdfsIntEventCode EC_XdfsDbMempFclose = { EC_XdfsDbMempFcloseValue };

const XdfsIntEventCode EC_XdfsDbMempFput = { EC_XdfsDbMempFputValue };

const XdfsIntEventCode EC_XdfsDbEnvCreate = { EC_XdfsDbEnvCreateValue };

void
xdfs_generate_pathint_event_internal (XdfsPathIntEventCode _code, const char* _srcfile, gint _srcline, Path* path, int err)
{
  XdfsPathIntEvent *_e = g_new0 (XdfsPathIntEvent, 1);
  _e->code = _code.code;
  _e->srcline = _srcline;
  _e->srcfile = _srcfile;
  _e->path = path;
  _e->err = err;
  eventdelivery_event_deliver ((GenericEvent*) _e);
}

const char*
Xdfs_PathInt_event_field_to_string (GenericEvent* ev, gint field)
{
  XdfsPathIntEvent* it = (XdfsPathIntEvent*) ev;
  switch (field)
    {
    case 0: return eventdelivery_path_to_string (it->path);
    case 1: return eventdelivery_int_to_string (it->err);
    default: abort ();
    }
}

const XdfsPathIntEventCode EC_XdfsDbEnvOpen = { EC_XdfsDbEnvOpenValue };

const XdfsIntEventCode EC_XdfsDbCursor = { EC_XdfsDbCursorValue };

const XdfsIntEventCode EC_XdfsDbCursorGet = { EC_XdfsDbCursorGetValue };

const XdfsIntEventCode EC_XdfsDbCursorDel = { EC_XdfsDbCursorDelValue };

const XdfsIntEventCode EC_XdfsDbCursorClose = { EC_XdfsDbCursorCloseValue };

void
xdfs_generate_void_event_internal (XdfsVoidEventCode _code, const char* _srcfile, gint _srcline)
{
  XdfsVoidEvent *_e = g_new0 (XdfsVoidEvent, 1);
  _e->code = _code.code;
  _e->srcline = _srcline;
  _e->srcfile = _srcfile;
  eventdelivery_event_deliver ((GenericEvent*) _e);
}

const XdfsVoidEventCode EC_XdfsMissingInode = { EC_XdfsMissingInodeValue };

const XdfsVoidEventCode EC_XdfsMissingLink = { EC_XdfsMissingLinkValue };

const XdfsVoidEventCode EC_XdfsMissingShort = { EC_XdfsMissingShortValue };

const XdfsVoidEventCode EC_XdfsInvalidRecordLength = { EC_XdfsInvalidRecordLengthValue };

void
xdfs_generate_path_event_internal (XdfsPathEventCode _code, const char* _srcfile, gint _srcline, Path* path)
{
  XdfsPathEvent *_e = g_new0 (XdfsPathEvent, 1);
  _e->code = _code.code;
  _e->srcline = _srcline;
  _e->srcfile = _srcfile;
  _e->path = path;
  eventdelivery_event_deliver ((GenericEvent*) _e);
}

const char*
Xdfs_Path_event_field_to_string (GenericEvent* ev, gint field)
{
  XdfsPathEvent* it = (XdfsPathEvent*) ev;
  switch (field)
    {
    case 0: return eventdelivery_path_to_string (it->path);
    default: abort ();
    }
}

const XdfsPathEventCode EC_XdfsLinkDepthExceeded = { EC_XdfsLinkDepthExceededValue };

const XdfsVoidEventCode EC_XdfsIndirectLinkDepthExceeded = { EC_XdfsIndirectLinkDepthExceededValue };

const XdfsPathEventCode EC_XdfsImmutableContainer = { EC_XdfsImmutableContainerValue };

const XdfsPathEventCode EC_XdfsFileExists = { EC_XdfsFileExistsValue };

const XdfsVoidEventCode EC_XdfsMalformedCanonicalPath = { EC_XdfsMalformedCanonicalPathValue };

const XdfsPathEventCode EC_XdfsOpenWriteFailed = { EC_XdfsOpenWriteFailedValue };

const XdfsPathEventCode EC_XdfsOpenReadFailed = { EC_XdfsOpenReadFailedValue };

const XdfsIntEventCode EC_XdfsMmapFailed = { EC_XdfsMmapFailedValue };

const XdfsIntEventCode EC_XdfsMunmapFailed = { EC_XdfsMunmapFailedValue };

const XdfsPathEventCode EC_XdfsWriteFailed = { EC_XdfsWriteFailedValue };

const XdfsPathEventCode EC_XdfsCloseFailed = { EC_XdfsCloseFailedValue };

const XdfsPathIntEventCode EC_XdfsMkdirFailed = { EC_XdfsMkdirFailedValue };

const XdfsIntEventCode EC_XdfsInvalidFileType = { EC_XdfsInvalidFileTypeValue };

const XdfsPathEventCode EC_XdfsNotADirectory = { EC_XdfsNotADirectoryValue };

const XdfsPathIntEventCode EC_XdfsStatFailed = { EC_XdfsStatFailedValue };

const XdfsVoidEventCode EC_XdfsAlreadyExists = { EC_XdfsAlreadyExistsValue };

const XdfsIntEventCode EC_XdfsNoSuchView = { EC_XdfsNoSuchViewValue };

const XdfsVoidEventCode EC_XdfsCannotDeleteRoot = { EC_XdfsCannotDeleteRootValue };

const XdfsIntEventCode EC_XdfsUnlinkFailed = { EC_XdfsUnlinkFailedValue };

const XdfsVoidEventCode EC_XdfsFsyncFailed = { EC_XdfsFsyncFailedValue };

